- Controller Constraint:

  - Reference: CC-PSI-1
    Link: UCA-PSI-1
    Text: Python script must provide images when there are new images available

  - Reference: CC-PSI-100
    Link: UCA-PSI-100
    Text: Python script must not provide images which are old (> x seconds)

  - Reference: CC-PSI-101
    Link: UCA-PSI-101
    Text: Python script must not provide images of poor quality (blurry, dark etc.)

  - Reference: CC-PSI-1000
    Link: UCA-PSI-1000
    Text: Python script must provide images within x seconds after environment images have been received from GStreamer

  - Reference: CC-GG-1
    Link: UCA-GG-1
    Text: Python script must provide a go cmd to start GStreamer when it is not running

  - Reference: CC-GG-2
    Link: UCA-GG-2
    Text: Python script must provide a go cmd with a valid config when GStreamer's config is inaccurate

  - Reference: CC-GG-100
    Link: UCA-GG-101
    Text: Python script must not provide a go cmd with inaccurate config file to GStreamer

  - Reference: CC-GG-101
    Link: UCA-GG-102
    Text: Python script must not provide a go cmd when GStreamer is already running with a valid config

  - Reference: CC-GG-1000
    Link: UCA-GG-1000
    Text: Python script must provide go cmd to GStreamer so that camera can send environment images within X seconds of systemd starting the Python script

  - Reference: CC-GG-1001
    Link: UCA-GG-1001
    Text: Python script must provide go cmd to GStreamer within x seconds after GStreamer has been inactive, or it is active with the wrong config

  - Reference: CC-MC-1
    Link: UCA-MC-1
    Text: Python script must provide motor control with reduced power (< P) when relative velocity and distance to an obstacle mean that a collision is imminent

  - Reference: CC-MC-2
    Link: UCA-MC-2
    Text: Python script must provide motor control with power 0 when the vehicle is moving and it has reached the final destination

  - Reference: CC-MC-3
    Link: UCA-MC-3
    Text: Python script must provide motor control with power 0 when a collision occurs

  - Reference: CC-MC-4
    Link: UCA-MC-4
    Text: Python script must provide motor control with power > 0 when there is no obstacle, no faults, the vehicle has not reached destination and it is stationary

  - Reference: CC-MC-5
    Link: UCA-MC-5
    Text: Python script must provide motor control with power 0 before program terminates

  - Reference: CC-MC-6
    Link: UCA-MC-6
    Text: Python script must provide motor control with updated trajectory when there is an obstacle imminently in the current trajectory or a quicker direction to the destination

  - Reference: CC-MC-100
    Link: UCA-MC-100
    Text: Python script must not provide motor control with excessive power (> P) which will result in a relative velocity to an obstacle that will cause an imminent collision

  - Reference: CC-MC-101
    Link: UCA-MC-101
    Text: Python script must not provide motor control with power > 0 when the vehicle is at its final destination

  - Reference: CC-MC-102
    Link: UCA-MC-102
    Text: Python script must not provide motor control with power > 0 when a collision has occurred

  - Reference: CC-MC-103
    Link: UCA-MC-103
    Text: Python script must not provide motor control with power 0 when there is no obstacle in its path and the end has not been reached

  - Reference: CC-MC-104
    Link: UCA-MC-104
    Text: Python script must not provide motor control with power > 0 after it has given final power 0 command before program terminates

  - Reference: CC-MC-105
    Link: UCA-MC-105
    Text: Python script must not provide motor control with inaccurate updated trajectory that steers the vehicle towards collision or away from quickest route to destination

  - Reference: CC-MC-1000
    Link: UCA-MC-1000
    Text: Python script must provide motor control within X seconds after relative velocity and distance to an obstacle mean that a collision is imminent

  - Reference: CC-MC-1001
    Link: UCA-MC-1001
    Text: Python script must provide motor control with power 0 within X seconds when vehicle has reached the final destination

  - Reference: CC-MC-1002
    Link: UCA-MC-1002
    Text: Python script must provide motor control with power 0 within X seconds when a collision occurs

  - Reference: CC-MC-1003
    Link: UCA-MC-1003
    Text: Python script must send motor control every X seconds

  - Reference: CC-MC-1004
    Link: UCA-MC-1004
    Text: Python script must not provide motrol control with updated trajectory too early when changing direction to avoid an obstacle

  - Reference: CC-MC-1005
    Link: UCA-MC-1005
    Text: Python script must not provide motrol control with updated trajectory too late when changing direction to avoid an obstacle
